#-----------------------------------------------------------------------------
%{?!dist:	%define	dist	.ok}
%define		majvers		%(echo %{version} | cut -d '.' -f1-2)
#-----------------------------------------------------------------------------
Name		:	guile
Version		:	3.0.10
Release		:	17.0.10.rel%{?dist}
Summary		:	A GNU implementation of Scheme for application extensibility

Packager	:	Osukiss Project	<build-ok@osukiss.org>

License		:	LGPLv3+
URL		:	http://www.gnu.org/software/guile/

Source0		:	%{name}-%{version}.tar.xz
#-----------------------------------------------------------------------------
BuildRequires	:	gcc
BuildRequires	:	libtool
BuildRequires	:	gmp
BuildRequires	:	readline
BuildRequires	:	gettext
BuildRequires	:	libunistring
BuildRequires	:	libffi
BuildRequires	:	gc-devel

Requires	:	coreutils
#-----------------------------------------------------------------------------
%description
GUILE (GNU's Ubiquitous Intelligent Language for Extension) is a library
implementation of the Scheme programming language, written in C.  GUILE
provides a machine-independent execution platform that can be linked in
as a library during the building of extensible programs.
 
Install the guile package if you'd like to add extensibility to programs
that you are developing.
 
#-----------------------------------------------------------------------------
%files			
%defattr(-,root,root,-)
%{_bindir}/guild
%{_bindir}/%{name}
%{_bindir}/%{name}-tools
%{_libdir}/lib%{name}-%{majvers}.so.*
%{_libdir}/%{name}/%{majvers}/ccache/ice-9/*.go
%{_libdir}/%{name}/%{majvers}/ccache/ice-9/peg/*.go
%{_libdir}/%{name}/%{majvers}/ccache/language/*.go
%{_libdir}/%{name}/%{majvers}/ccache/language/brainfuck/*.go
%{_libdir}/%{name}/%{majvers}/ccache/language/bytecode/spec.go
%{_libdir}/%{name}/%{majvers}/ccache/language/cps/*.go
%{_libdir}/%{name}/%{majvers}/ccache/language/cps/guile-vm/*.go
%{_libdir}/%{name}/%{majvers}/ccache/language/ecmascript/*.go
%{_libdir}/%{name}/%{majvers}/ccache/language/elisp/*.go
%{_libdir}/%{name}/%{majvers}/ccache/language/elisp/runtime/*.go
%{_libdir}/%{name}/%{majvers}/ccache/language/scheme/*.go
%{_libdir}/%{name}/%{majvers}/ccache/language/tree-il/*.go
%{_libdir}/%{name}/%{majvers}/ccache/language/value/spec.go
%{_libdir}/%{name}/%{majvers}/ccache/language/wisp/spec.go
%{_libdir}/%{name}/%{majvers}/ccache/oop/goops.go
%{_libdir}/%{name}/%{majvers}/ccache/oop/goops/*.go
%{_libdir}/%{name}/%{majvers}/ccache/rnrs.go
%{_libdir}/%{name}/%{majvers}/ccache/rnrs/*.go
%{_libdir}/%{name}/%{majvers}/ccache/rnrs/arithmetic/*.go
%{_libdir}/%{name}/%{majvers}/ccache/rnrs/bytevectors/*.go
%{_libdir}/%{name}/%{majvers}/ccache/rnrs/io/*.go
%{_libdir}/%{name}/%{majvers}/ccache/rnrs/records/*.go
%{_libdir}/%{name}/%{majvers}/ccache/scheme/*.go
%{_libdir}/%{name}/%{majvers}/ccache/scripts/*.go
%{_libdir}/%{name}/%{majvers}/ccache/srfi/*.go
%{_libdir}/%{name}/%{majvers}/ccache/srfi/srfi-*/*.go
%{_libdir}/%{name}/%{majvers}/ccache/statprof.go
%{_libdir}/%{name}/%{majvers}/ccache/system/*.go
%{_libdir}/%{name}/%{majvers}/ccache/system/base/*.go
%{_libdir}/%{name}/%{majvers}/ccache/system/base/types/*.go
%{_libdir}/%{name}/%{majvers}/ccache/system/repl/*.go
%{_libdir}/%{name}/%{majvers}/ccache/system/vm/*.go
%{_libdir}/%{name}/%{majvers}/ccache/sxml/*.go
%{_libdir}/%{name}/%{majvers}/ccache/sxml/ssax/*.go
%{_libdir}/%{name}/%{majvers}/ccache/texinfo.go
%{_libdir}/%{name}/%{majvers}/ccache/texinfo/*.go
%{_libdir}/%{name}/%{majvers}/ccache/web/*.go
%{_libdir}/%{name}/%{majvers}/ccache/web/server/http.go
%{_libdir}/%{name}/%{majvers}/extensions/%{name}-readline.so
%{_libdir}/%{name}/%{majvers}/extensions/%{name}-readline.so.0*
%{_datadir}/%{name}/%{majvers}/ice-9
%{_datadir}/%{name}/%{majvers}/language
%{_datadir}/%{name}/%{majvers}/oop
%{_datadir}/%{name}/%{majvers}/rnrs
%{_datadir}/%{name}/%{majvers}/scripts
%{_datadir}/%{name}/%{majvers}/srfi
%{_datadir}/%{name}/%{majvers}/sxml
%{_datadir}/%{name}/%{majvers}/system
%{_datadir}/%{name}/%{majvers}/texinfo
%{_datadir}/%{name}/%{majvers}/web
%{_datadir}/%{name}/%{majvers}/%{name}-procedures.txt
%{_datadir}/%{name}/%{majvers}/*.scm
%{_datadir}/%{name}/%{majvers}/scheme/*.scm
%{_infodir}/r5rs.info.gz
%{_infodir}/%{name}.info*.gz
%{_mandir}/man1/%{name}.1.gz

#=============================================================================
%package		devel
Summary		:	Libraries and header files for the GUILE extensibility library

#-----------------------------------------------------------------------------
Requires	:	%{name} = %{version}-%{release}
Requires	:	gmp
Requires	:	gc-devel
Requires	:	pkg-config
 
#-----------------------------------------------------------------------------
%description		devel
The guile-devel package includes the libraries, header files, etc.,
that you'll need to develop applications that are linked with the
GUILE extensibility library.
 
You need to install the guile-devel package if you want to develop
applications that will be linked to GUILE.  You'll also need to
install the guile package.

#-----------------------------------------------------------------------------
%files			devel
%defattr(-,root,root,-)
%{_bindir}/guile-config
%{_bindir}/guile-snarf
%{_includedir}/%{name}/%{majvers}/libguile.h
%{_includedir}/%{name}/%{majvers}/readline.h
%{_includedir}/%{name}/%{majvers}/lib%{name}/*.h
%{_libdir}/lib%{name}-%{majvers}.so
%{_libdir}/pkgconfig/%{name}-%{majvers}.pc
%{_datadir}/aclocal/%{name}.m4

#=============================================================================
%prep
%setup -q 

#-----------------------------------------------------------------------------
#building application
%build

autoreconf -vif
./configure						\
        --prefix=%{_prefix}				\
        --includedir=%{_includedir}			\
	--exec-prefix=%{_exec_prefix}			\
	--libexecdir=%{_libexecdir}			\
        --sysconfdir=%{_sysconfdir}			\
        --sbindir=%{_sbindir}				\
	--mandir=%{_mandir}				\
	--libdir=%{_libdir}				\
	--datadir=%{_datadir}				\
	--infodir=%{_infodir}				\
	--docdir=%{_defaultdocdir}/%{name}-%{version}	\
	--disable-static				\
	--disable-error-on-warning

sed -i							\
  -e 's/ -shared / -Wl,-O1,--as-needed\0/g'		\
  libtool

%define _smp_mflags -j%(/usr/bin/getconf _NPROCESSORS_ONLN)
%{__make} %{_smp_mflags}

#-----------------------------------------------------------------------------
%clean
%{__rm} -rf %{buildroot}

#-----------------------------------------------------------------------------
#installing program
%install
%{__rm} -rf %{buildroot}

%{__make}						\
	DESTDIR=%{buildroot}				\
	install

#removing empty useless dir
%{__rm} -fr %{buildroot}%{_infodir}/dir

#To remove libtool library
find 							\
	%{buildroot}%{_libdir}				\
	-name \*.la					\
	-delete

# Our gdb doesn't support guile yet
rm -f %{buildroot}%{_libdir}/lib%{name}*gdb.scm

#-----------------------------------------------------------------------------
%changelog
